//+------------------------------------------------------------------+
//|                                          i-GentorLSMAEMA_v02.mq5 | 
//|                               Copyright  2007, FX Sniper, KimIV | 
//|                                              http://www.kimiv.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, FX Sniper, KimIV"
#property link "http://www.kimiv.ru"
#property description ""
//---   
#property version   "1.00"
//---     
#property indicator_separate_window
//---       
#property indicator_height 40
//---        
#property indicator_maximum +3.9
#property indicator_minimum +0.3
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0      //        
//+----------------------------------------------+
//---   
#property indicator_buffers 4
//---  2  
#property indicator_plots   2
//+----------------------------------------------+
//|     1            |
//+----------------------------------------------+
//---   1   
#property indicator_type1   DRAW_COLOR_LINE
//---      
#property indicator_color1 clrRed,clrGray,clrLime
//---   - 
#property indicator_style1  STYLE_SOLID
//---     5
#property indicator_width1  5
//---   
#property indicator_label1  "Signal line"
//+----------------------------------------------+
//|     2            |
//+----------------------------------------------+
//---      
#property indicator_type2 DRAW_COLOR_LINE
//---      
#property indicator_color2 clrYellow,clrGray,clrBlue
//---   - 
#property indicator_style2 STYLE_SOLID
//---     5
#property indicator_width2 5
//---   
#property indicator_label2  "Signal Arrow"
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint                 LSMAPeriod=25;         //  LSMA
input uint                 MAPeriod=34;           //  MA
input ENUM_MA_METHOD       MAType=MODE_EMA;       //  
input ENUM_APPLIED_PRICE   MAPrice=PRICE_TYPICAL; //  
//+----------------------------------------------+
//---   ,    
//---      
double Ind1Buffer[];
double ColorInd1Buffer[];
double Ind2Buffer[];
double ColorInd2Buffer[];
//---
double res,lengthvar;
//---      
int MA_Handle;
//---      
int min_rates_total;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---      
   min_rates_total=int(MathMax(LSMAPeriod,MAPeriod));
   lengthvar=(LSMAPeriod+1)/3.0;
   res=6.0/(LSMAPeriod*(LSMAPeriod+1.0));
//---    iMA
   MA_Handle=iMA(_Symbol,PERIOD_CURRENT,MAPeriod,0,MAType,MAPrice);
   if(MA_Handle==INVALID_HANDLE)
     {
      Print("      iMA");
      return(INIT_FAILED);
     }
//---      
   SetIndexBuffer(0,Ind1Buffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(Ind1Buffer,true);
//---          
   SetIndexBuffer(1,ColorInd1Buffer,INDICATOR_COLOR_INDEX);
//---       
   ArraySetAsSeries(ColorInd1Buffer,true);
//---      
   SetIndexBuffer(2,Ind2Buffer,INDICATOR_DATA);
//---       
   ArraySetAsSeries(Ind2Buffer,true);
//---          
   SetIndexBuffer(3,ColorInd2Buffer,INDICATOR_COLOR_INDEX);
//---       
   ArraySetAsSeries(ColorInd2Buffer,true);
//---      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---      
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---         
   string short_name="i-GentorLSMAEMA_v02";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(BarsCalculated(MA_Handle)<rates_total || rates_total<min_rates_total) return(RESET);
//---    
   int to_copy,limit,bar;
   double MA[];
//---         limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=rates_total-int(MAPeriod)-1; //      
   else limit=rates_total-prev_calculated; //      
   to_copy=limit+1;
//---    ,     
   ArraySetAsSeries(MA,true);
   ArraySetAsSeries(close,true);
//---      
   if(CopyBuffer(MA_Handle,0,0,to_copy,MA)<=0) return(RESET);
//---     2
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      Ind2Buffer[bar]=+1.4;
      ColorInd2Buffer[bar]=1;
      if(close[bar]>MA[bar]) ColorInd2Buffer[bar]=2;
      else if(close[bar]<MA[bar]) ColorInd2Buffer[bar]=0;
     }
//---     
   if(prev_calculated>rates_total || prev_calculated<=0) limit=rates_total-int(LSMAPeriod)-1;
//---     1
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      Ind1Buffer[bar]=+3;
      ColorInd1Buffer[bar]=1;
      double sum=0;
      for(int iii=int(LSMAPeriod); iii>=1; iii--)
        {
         double tmp=(iii-lengthvar)*close[LSMAPeriod-iii+bar];
         sum+=tmp;
        }
      double wt=sum*res;
      //---
      if(wt>close[bar]) ColorInd1Buffer[bar]=0;
      else if(wt<close[bar]) ColorInd1Buffer[bar]=2;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
